<!DOCTYPE html>
<html>
<head>
    <title>Task 59.20</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
<div class="container">
  <div class="jumbotron container"> 
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-fname">First Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="input-lname">Last Name</label>
      </div>
      <div class="col-sm-9">
        <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
      </div>
    </div>
    <div class="row form-group">
      <div class="col-sm-3">
        <label for="car-select">Car</label>
      </div>
      <div class="col-sm-3">
        <select id="car-select" name="car" class="form-control">
        </select>
      </div>
      <div class="col-sm-3 text-center">
        <label for="car-type-select ">Car type</label>
      </div>
      <div class="col-sm-3">
        <select id="car-type-select" name="car-type" disabled class="form-control">
        </select>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-12" style="text-align: right;">
        <button id="btn_send" class="btn btn-info"> Send </button>
      </div>
    </div>
  </div>
</div>
<script>
$(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    // gán sự kiện change cho select car
    $('#car-select').on('change', function(){
        onBtnChangeCarSelect()
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    $.ajax({
        url: "http://localhost:8080/devcamp-cars",
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
            console.log(responseObject);
            for(var bI = 0; bI < responseObject.length; bI ++){
                $('#car-select').append($('<option>', {
                    value: responseObject[bI].carCode,
                    text: responseObject[bI].carName
                }));
            }
        },
        error: function(error){
            console.log(error.responseText);
        }
    });

    // Hàm xử lý khi change select car
    function onBtnChangeCarSelect(){
        "use strict";
        console.log("change select");  
        var vCarCode = $("#car-select").val(); // lấy carCode từ select
        console.log(vCarCode);
        //Gọi APi theo carCode
        $.ajax({
            url: "http://localhost:8080/devcamp-cartypes?carCode=" + vCarCode,
            type: "GET",
            dataType: 'json',
            success: function(responseObject){
                console.log(responseObject);
                $('#car-type-select').empty(); // Làm rỗng dữ liệu select car type trước khi đổ dữ liệu vào
                if(responseObject.length > 0 ){ // Nếu có dữ liệu car type của car được chọn
                    $('#car-type-select').removeAttr("disabled"); // Gỡ bỏ thuộc tính disabled
                    // Xét các car type và đổ vào select
                    for(var bI = 0; bI < responseObject.length; bI ++){
                        $('#car-type-select').append($('<option>', {
                            value: responseObject[bI].typeCode,
                            text: responseObject[bI].typeName
                        }));
                    }
                } else {
                    $('#car-type-select').attr("disabled", "disabled"); // thêm thuộc tính disabled khi không có car type nào
                }    
                
            },
            error: function(error){
                console.log(error.responseText);
            }
        });
    }

});
</script> 


</body>
</html>


